<p align="center">
  <img height="150" src="https://git.odit.services/user/avatar/kauft.es/140">
  <h1 align="center">LinkyLinky 🔗</h1>
  <h3 align="center">A small url shortener, originaly developed for kauft.es</h3>
</p>

## Features
* Url shortinging to 18-byte hex ids
* Special shortening "providers" for well-used services

### Provider patterns
> The base pattern is always baseurl/providerOrShortCode

| Provider | Pattern | Resolves to | Example | Notes |
| - | - | - | - | - |
| Native (Shortcode) | `/id` | Whatever the database entry points to | https://kauft.es/den-hut | None |
| YouTube (Video) | `/yt/id` | `https://youtu.be/id` | https://kauft.es/yt/dQw4w9WgXcQ | None |
| YouTube (Playlist) | `/ytpl/id` | `https://youtube.com/playlist?list=id` | https://kauft.es/ytpl/PLKIxB9vhdS_3x0A5za3mmu1wdoolgRQ65 | Remember: Private playlists will result in user-side errors |
| Amazon | `/a/id` | `https://amazon.de/dp/id` | https://kauft.es/a/B08Z2TXCPY | Recognizes all kind of cursed amazon urls (+smile and others) |
| eBay | `/e/id` | `https://ebay.de/itm/id` | https://kauft.es/e/373831556670 | Only tested with German eBay |
| Reddit | `/r/id` | `https://redd.it/id` | https://kauft.es/r/4vapin | Powered by the awesome work of u/TheAppleFreak https://kauft.es/r/4vapin |

## Dev Setup 🛠
> Runs on port 3000

#### Yarn
```bash
yarn
yarn migrate
yarn dev
```

#### NPM
```bash
npm i
npm run migrate
npm run dev
```

## Docker 🐳
> Runs on port 3000
```
docker-compose build
docker-compose up
```